#include <iostream>

#include <string>

void stringSample() {
  std::string s = "value";

  std::cout << s << "\n";

  s[0] = 'p';

  std::cout << s << "\n";

  if (s.empty()) {
    std::cout << "s is empty\n";
  } else {
    std::cout << "s is not empty\n";
  }

  // iterators
  //for (std::string::size_type i = 0; i < s.length(); ++i) {
  for (int i = 0; i < s.length(); ++i) {
    ++s[i];
  }
  std::cout << "Now after advancing a character s = " << s << "\n";

  //for (auto i = s.begin(); i != s.end(); ++i)
  for (std::string::iterator i = s.begin(); i != s.end(); ++i) {
    --*i;
  }
  std::cout << "Now after decrementing each character, s = " << s << "\n";

  // Range-For Loop
  //for (auto i : s) {
  for (char i : s) {
    ++i;
  }
  std::cout << "Now after advancing a character s = " << s << "\n";

}

int main() {
  stringSample();
  
  return 0;
}
